/*
 * Created on 31/08/2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package prontuario;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Iterator;
import java.util.Vector;

/**
 * @author Lamberto Augusto
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class CadastroProntuario {

	private FileInputStream inputfile;

	private FileOutputStream outputfile;

	private String arquivo;

	private Vector prontuarios;

	/**
	 *  
	 */
	public CadastroProntuario() {
		this.arquivo = "prontuario.dat";
		this.prontuarios = new Vector();
		this.ler();
	}

	/**
	 * @return Returns the prontuarios.
	 */
	public Vector getProntuarios() {
		return prontuarios;
	}

	/**
	 * @param prontuarios
	 *            The prontuarios to set.
	 */
	public void setProntuarios(Vector prontuarios) {
		this.prontuarios = prontuarios;
	}

	public boolean tahOk(Prontuario pront) {
		boolean retorno = false;
		if (pront != null && pront.getRegistro().getAla() != null
				&& pront.getRegistro().getConvenio() != null
				&& pront.getRegistro().getCpf() != null
				&& pront.getRegistro().getIdentidade() != null
				&& pront.getRegistro().getMatricula() != null
				&& pront.getRegistro().getMedico() != null
				&& pront.getNmero() > 0 && pront.getPaciente().tahOk()
				&& pront.getRegistro().getResponsavel() != null
				&& pront.getRegistro().getSegurado() != null
				&& pront.getRegistro().getValidade() != null) {
			retorno = true;
		}
		return retorno;
	}

	public boolean inserir(Prontuario pront) {
		boolean retorno = false;
		if (this.tahOk(pront)) {
			this.prontuarios.addElement(pront);
			retorno = true;
			this.salvar();
		}		
		return retorno;
	}

	public boolean apagar(int numero) {
		boolean retorno = false;
		if (numero > 0) {
			Iterator it = this.prontuarios.iterator();
			while (it.hasNext()) {
				Prontuario temp = (Prontuario) it.next();
				if (temp.getNmero() == numero) {
					this.prontuarios.removeElement(temp);
					retorno = true;
				}
			}
		}
		this.salvar();
		return retorno;
	}

	public Prontuario procurar(int numero) {
		Prontuario retorno = null;
		if (numero > 0) {
			Iterator it = this.prontuarios.iterator();
			while (it.hasNext()) {
				Prontuario temp = (Prontuario) it.next();
				if (temp.getNmero() == numero) {
					retorno = temp;
				}
			}
		}
		return retorno;
	}

	public Vector procurarNome(String paciente) {
		Vector retorno = new Vector();
		if (paciente != null) {
			Iterator it = this.prontuarios.iterator();
			while (it.hasNext()) {
				Prontuario temp = (Prontuario) it.next();
				if (temp.getPaciente().getNome().equals(paciente)) {
					retorno.addElement(temp);
				}
			}
		}
		return retorno;
	}

	protected synchronized void ler() {
		ObjectInputStream obj = null;
		Prontuario temp = null;
		try {
			inputfile = new FileInputStream(arquivo);
			obj = new ObjectInputStream(inputfile);
			temp = (Prontuario) obj.readObject();
			do {
				try {
					if (temp != null) {
						this.prontuarios.addElement(temp);
					}
					temp = (Prontuario) obj.readObject();
				} catch (IOException e) {
					temp = null;
				}
			} while (temp != null);
			obj.close();
			inputfile.close();
		} catch (FileNotFoundException e) {
			File f = new File(arquivo);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	protected synchronized void salvar() {

		try {
			outputfile = new FileOutputStream(new File(arquivo));
			ObjectOutputStream obj = new ObjectOutputStream(outputfile);
			Iterator iterator = this.prontuarios.iterator();
			while (iterator.hasNext()) {
				Prontuario temp = (Prontuario) iterator.next();
				if (temp != null) {
					obj.writeObject(temp);
					obj.flush();
				}
			}
			obj.close();
			outputfile.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
